#include <iostream>
#include <string.h> // old c string functions
#include "patient2.h"

using namespace std;

CPatient::CPatient(const char *n, int a, char g)	// Normal constructor
{
	cout << "constructing patient" << endl;
	p = new char[strlen(n) +1];
	strcpy(p,n);
	age = a;
	gender = g;
}

CPatient::CPatient()  			//default constructor  no arguments
{
	cout << "default constructor" << endl;
	p = new char[strlen("A.N.Other") +1];
	strcpy(p,"A.N.Other");
	age = 0;
	gender = 'M';
}

CPatient::~CPatient()  			//destructor
{ 	
	cout << "default destructor" << endl;
	delete []p;
};

CPatient::CPatient(const CPatient& x)
{
	cout << "copy constructor" << endl;
	p = new char[strlen(x.p) +1];
	strcpy(p,x.p);
	age = x.age;
	gender = x.gender;
}

const CPatient& CPatient::operator=(const CPatient& x)  			
{
	if(this != &x)
	{
		delete []p; //release memory
		p = new char[strlen(x.p) +1];	//allocate memory for new name
		strcpy(p,x.p);
		age = x.age;
		gender = x.gender;
	}
	return (*this); //return invoking instance 
}

void CPatient::identify()
{
	cout << "name :" << p << endl;
	cout << "Age : " << age << endl;
	cout << "Gender :" << gender << endl;
}


void CPatient::set_name(char * n)
{
	delete []p;
	p = new char[strlen(n) +1];
	strcpy(p,n);
}

void CPatient::set_age(int a) 
{ 
	age = a; 
}

void CPatient::set_gender(char g) 
{
 	gender = g; 
}


const char * CPatient::get_name()
{
	return p;
}

int CPatient:: get_age() 
{ 
	return age; 
}

char CPatient::get_gender() 
{
 	return gender; 
}








